import * as express from 'express';
import User from '../models/user'

export class UserController {
    login = (req: express.Request, res: express.Response) => {
        let username = req.body.username;
        let password = req.body.password;
        let type = req.body.type

        User.findOne({ 'korisnickoIme': username, 'lozinka': password, 'tip': type }, (err, user) => {
            if (err) console.log(err);
            else res.json(user)
        })
    }

    getUser = (req: express.Request, res: express.Response) => {
        let username = req.body.username;

        User.findOne({ 'korisnickoIme': username }, (err, user) => {
            if (err) console.log(err);
            else res.json(user)
        })
    }

    dodaj = (req: express.Request, res: express.Response) => {
        let username = req.body.username;
        let naziv = req.body.naziv;
        let cena = parseInt(req.body.cena);

        User.collection.updateOne({ 'korisnickoIme': username }, { $push: { 'lista': { 'proizvod': naziv, 'cena': cena, 'kupio': null, 'anonimno': false } } })
        res.json({ 'msg': 'ok' })
    }

    dohvatiOstale = (req: express.Request, res: express.Response) => {
        let username = req.body.username;

        User.find({ $and: [{ 'korisnickoIme': { $ne: username } }, { 'tip': { $ne: 'administrator' } }] }, (err, users) => {
            if (err) console.log(err);
            else res.json(users)
        })
    }

    kupiProizvod = (req: express.Request, res: express.Response) => {
        let username = req.body.username;
        let izabrani = req.body.birani;
        let proizvod = req.body.proizvod;
        let anonimno = parseInt(req.body.anonimno);

        User.findOne({ 'korisnickoIme': izabrani }, (err, tmp) => {
            let cena = 0;
            let lista = tmp.lista;

            lista.forEach(l => {
                if (l.proizvod == proizvod) {
                    cena = l.cena;
                    l.kupio = username;
                    l.anonimno = anonimno == 1;
                }
            });

            User.collection.updateOne({ 'korisnickoIme': izabrani }, { $set: { 'lista': lista } })
            User.collection.updateOne({ 'korisnickoIme': username }, { $inc: { 'naStanju': -cena } })
            User.collection.updateOne({ 'korisnickoIme': username }, { $inc: { 'potroseno': cena } })
            res.json({ 'msg': 'ok' })
        })
    }

    uplati = (req: express.Request, res: express.Response) => {
        let username = req.body.username;

        User.collection.updateOne({ 'korisnickoIme': username }, { $inc: { 'naStanju': 5000 } })
        res.json({ 'msg': 'ok' })
    }
}